gtkmm: Gtk::Gesture Class Reference

gtkmm 4.6.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::Gesture Class Reference
Event Controllers and Gestures

Abstract base class for gestures. More...

`#include <gtkmm/gesture.h>`

Inheritance diagram for Gtk::Gesture:
[legend]

## Public Member Functions
| Gesture (Gesture && src) noexcept
Gesture & | operator= (Gesture && src) noexcept
| ~Gesture () noexcept override
GtkGesture * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkGesture * | gobj () const
| Provides access to the underlying C GObject. More...
GtkGesture * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gdk::Device > | get_device ()
| Returns the logical `Gdk::Device` that is currently operating on gesture. More...
Glib::RefPtr< const Gdk::Device > | get_device () const
| Returns the logical `Gdk::Device` that is currently operating on gesture. More...
bool | set_state (EventSequenceState state)
| Sets the state of all sequences that gesture is currently interacting with. More...
EventSequenceState | get_sequence_state (Gdk::EventSequence * sequence) const
| Returns the sequence state, as seen by gesture. More...
bool | set_sequence_state (Gdk::EventSequence * sequence, EventSequenceState state)
| Sets the state of sequence in gesture. More...
std::vector< const Gdk::EventSequence * > | get_sequences () const
| Returns the list of Gdk::EventSequences currently being interpreted. More...
Gdk::EventSequence * | get_last_updated_sequence ()
| Returns the `Gdk::EventSequence` that was last updated on gesture. More...
const Gdk::EventSequence * | get_last_updated_sequence () const
| Returns the `Gdk::EventSequence` that was last updated on gesture. More...
bool | handles_sequence (Gdk::EventSequence * sequence) const
| Returns `true` if gesture is currently handling events corresponding to sequence. More...
Glib::RefPtr< Gdk::Event > | get_last_event (Gdk::EventSequence * sequence)
| Returns the last event that was processed for sequence. More...
Glib::RefPtr< const Gdk::Event > | get_last_event (Gdk::EventSequence * sequence) const
| Returns the last event that was processed for sequence. More...
bool | get_point (Gdk::EventSequence * sequence, double & x, double & y) const
| If sequence is currently being interpreted by gesture, returns `true` and fills in x and y with the last coordinates stored for that event sequence. More...
bool | get_bounding_box (Gdk::Rectangle & rect) const
| If there are touch sequences being currently handled by gesture, returns `true` and fills in rect with the bounding box containing all active touches. More...
bool | get_bounding_box_center (double & x, double & y) const
| If there are touch sequences being currently handled by gesture, returns `true` and fills in x and y with the center of the bounding box containing all active touches. More...
bool | is_active () const
| Returns `true` if the gesture is currently active. More...
bool | is_recognized () const
| Returns `true` if the gesture is currently recognized. More...
void | group (const Glib::RefPtr< Gesture > & group_gesture)
| Adds gesture to the same group than group_gesture. More...
void | ungroup ()
| Separates gesture into an isolated group. More...
std::vector< Glib::RefPtr< Gesture > > | get_group ()
| Returns all gestures in the group of gesture. More...
std::vector< Glib::RefPtr< const Gesture > > | get_group () const
| Returns all gestures in the group of gesture. More...
bool | is_grouped_with (const Glib::RefPtr< Gesture > & other) const
| Returns `true` if both gestures pertain to the same group. More...
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_begin ()
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_end ()
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_update ()
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_cancel ()
Glib::SignalProxy< void(Gdk::EventSequence *, EventSequenceState)> | signal_sequence_state_changed ()
Glib::PropertyProxy_ReadOnly< unsigned int > | property_n_points () const
| The number of touch points that trigger recognition on this gesture. More...
Public Member Functions inherited from Gtk::EventController
| EventController (EventController && src) noexcept
EventController & | operator= (EventController && src) noexcept
| ~EventController () noexcept override
GtkEventController * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkEventController * | gobj () const
| Provides access to the underlying C GObject. More...
GtkEventController * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Widget * | get_widget ()
| Returns the `Gtk::Widget` this controller relates to. More...
const Widget * | get_widget () const
| Returns the `Gtk::Widget` this controller relates to. More...
void | reset ()
| Resets the controller to a clean state. More...
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events. More...
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events. More...
PropagationLimit | get_propagation_limit () const
| Gets the propagation limit of the event controller. More...
void | set_propagation_limit (PropagationLimit limit)
| Sets the event propagation limit on the event controller. More...
Glib::ustring | get_name () const
| Gets the name of controller. More...
void | set_name (const Glib::ustring & name)
| Sets a name on the controller that can be used for debugging. More...
Glib::RefPtr< const Gdk::Event > | get_current_event () const
| Returns the event that is currently being handled by the controller. More...
guint32 | get_current_event_time () const
| Returns the timestamp of the event that is currently being handled by the controller. More...
Glib::RefPtr< Gdk::Device > | get_current_event_device ()
| Returns the device of the event that is currently being handled by the controller. More...
Glib::RefPtr< const Gdk::Device > | get_current_event_device () const
| Returns the event that is currently being handled by the controller. More...
Gdk::ModifierType | get_current_event_state () const
| Returns the modifier state of the event that is currently being handled by the controller. More...
Glib::PropertyProxy_ReadOnly< Widget * > | property_widget () const
| The widget receiving the `Gdk::Events` that the controller will handle. More...
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events. More...
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events. More...
Glib::PropertyProxy< PropagationLimit > | property_propagation_limit ()
| The limit for which events this controller will handle. More...
Glib::PropertyProxy_ReadOnly< PropagationLimit > | property_propagation_limit () const
| The limit for which events this controller will handle. More...
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name for this controller, typically used for debugging purposes. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name for this controller, typically used for debugging purposes. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| Gesture ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::Gesture > | wrap (GtkGesture * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)

## Detailed Description

Abstract base class for gestures.

This is the base object for gesture recognition. Although this object is quite generalized to serve as a base for multi-touch gestures, it is suitable to implement single-touch and pointer-based gestures (using the special Gdk::EventSequence value for these).

The number of touches that a Gesture need to be recognized is controlled by the n-points property. If a gesture is keeping track of less or more than that number of sequences, it won't check whether the gesture is recognized.

As soon as the gesture has the expected number of touches, it will check regularly if it is recognized, the criteria to consider a gesture as "recognized" is left to Gesture subclasses.

A recognized gesture will then emit the following signals:

- signal_begin() when the gesture is recognized.
- A number of signal_update(), whenever an input event is processed.
- signal_end() when the gesture is no longer recognized.

## Event propagation

In order to receive events, a gesture needs to set a propagation phase through EventController::set_propagation_phase().

In the capture phase, events are propagated from the toplevel down to the target widget, and gestures that are attached to containers above the widget get a chance to interact with the event before it reaches the target.

In the bubble phase, events are propagated up from the target widget to the toplevel, and gestures that are attached to containers above the widget get a chance to interact with events that have not been handled yet.

## States of a sequence

Whenever input interaction happens, a single event may trigger a cascade of Gestures, both across the parents of the widget receiving the event and parallelly within an individual widget. It is a responsibility of the widgets using those gestures to set the state of touch sequences accordingly in order to enable cooperation of gestures around the Gdk::EventSequences triggering those.

Within a widget, gestures can be grouped through group(). Grouped gestures synchronize the state of sequences, so calling set_sequence_state() on one will effectively propagate the state throughout the group.

By default, all sequences start out in the Gtk::EventSequenceState::NONE state. Sequences in this state trigger the gesture event handler, but event propagation will continue unstopped by gestures.

If a sequence enters into the Gtk::EventSequenceState::DENIED state, the gesture group will effectively ignore the sequence, letting events go unstopped through the gesture, but the "slot" will still remain occupied while the touch is active.

If a sequence enters in the Gtk::EventSequenceState::CLAIMED state, the gesture group will grab all interaction on the sequence, by:

- Setting the same sequence to Gtk::EventSequenceState::DENIED on every other gesture group within the widget, and every gesture on parent widgets in the propagation chain.
- emitting signal_cancel() on every gesture in widgets underneath in the propagation chain.
- Stopping event propagation after the gesture group handles the event.

Note
  If a sequence is set early to Gtk::EventSequenceState::CLAIMED on Gdk::Event::Type::TOUCH_BEGIN/Gdk::Event::Type::BUTTON_PRESS (so those events are captured before reaching the event widget, this implies Gtk::PropagationPhase::CAPTURE), one similar event will be emulated if the sequence changes to Gtk::EventSequenceState::DENIED. This way event coherence is preserved before event propagation is unstopped again.

Sequence states can't be changed freely, see set_sequence_state() to know about the possible lifetimes of a Gdk::EventSequence.

Since gtkmm 3.14:

## Constructor & Destructor Documentation

## ◆ Gesture() [1/2]

Gtk::Gesture::Gesture | ( | Gesture && | src | ) |
| noexcept

## ◆ ~Gesture()

Gtk::Gesture::~Gesture | ( |  | ) |
| overridenoexcept

## ◆ Gesture() [2/2]

Gtk::Gesture::Gesture | ( |  | ) |
| protected

There is no create() method that corresponds to this constructor, because only derived classes shall be created.

## Member Function Documentation

## ◆ get_bounding_box()

bool Gtk::Gesture::get_bounding_box | ( | Gdk::Rectangle & | rect | ) | const

If there are touch sequences being currently handled by gesture, returns `true` and fills in rect with the bounding box containing all active touches.

Otherwise, `false` will be returned.

Note
  This function will yield unexpected results on touchpad gestures. Since there is no correlation between physical and pixel distances, these will look as if constrained in an infinitely small area, rect width and height will thus be 0 regardless of the number of touchpoints.

Parameters

  rect | Bounding box containing all active touches.

Returns
  `true` if there are active touches, `false` otherwise.

## ◆ get_bounding_box_center()

bool Gtk::Gesture::get_bounding_box_center | ( | double & | x,
|  | double & | y
| ) |  | const

If there are touch sequences being currently handled by gesture, returns `true` and fills in x and y with the center of the bounding box containing all active touches.

Otherwise, `false` will be returned.

Parameters

  x | X coordinate for the bounding box center.
  y | Y coordinate for the bounding box center.

Returns
  `false` if no active touches are present, `true` otherwise.

## ◆ get_device() [1/2]

Glib::RefPtr< Gdk::Device > Gtk::Gesture::get_device | ( |  | ) |

Returns the logical `Gdk::Device` that is currently operating on gesture.

This returns `nullptr` if the gesture is not being interacted.

Returns
  A `Gdk::Device`.

## ◆ get_device() [2/2]

Glib::RefPtr< const Gdk::Device > Gtk::Gesture::get_device | ( |  | ) | const

Returns the logical `Gdk::Device` that is currently operating on gesture.

This returns `nullptr` if the gesture is not being interacted.

Returns
  A `Gdk::Device`.

## ◆ get_group() [1/2]

std::vector< Glib::RefPtr< Gesture > > Gtk::Gesture::get_group | ( |  | ) |

Returns all gestures in the group of gesture.

Returns
  The list of `Gtk::Gesture`s.

## ◆ get_group() [2/2]

std::vector< Glib::RefPtr< const Gesture > > Gtk::Gesture::get_group | ( |  | ) | const

Returns all gestures in the group of gesture.

Returns
  The list of `Gtk::Gesture`s.

## ◆ get_last_event() [1/2]

Glib::RefPtr< Gdk::Event > Gtk::Gesture::get_last_event | ( | Gdk::EventSequence * | sequence | ) |

Returns the last event that was processed for sequence.

Note that the returned pointer is only valid as long as the sequence is still interpreted by the gesture. If in doubt, you should make a copy of the event.

Parameters

  sequence | A `Gdk::EventSequence`.

Returns
  The last event from sequence.

## ◆ get_last_event() [2/2]

Glib::RefPtr< const Gdk::Event > Gtk::Gesture::get_last_event | ( | Gdk::EventSequence * | sequence | ) | const

Returns the last event that was processed for sequence.

Note that the returned pointer is only valid as long as the sequence is still interpreted by the gesture. If in doubt, you should make a copy of the event.

Parameters

  sequence | A `Gdk::EventSequence`.

Returns
  The last event from sequence.

## ◆ get_last_updated_sequence() [1/2]

Gdk::EventSequence * Gtk::Gesture::get_last_updated_sequence | ( |  | ) |

Returns the `Gdk::EventSequence` that was last updated on gesture.

Returns
  The last updated sequence.

## ◆ get_last_updated_sequence() [2/2]

const Gdk::EventSequence * Gtk::Gesture::get_last_updated_sequence | ( |  | ) | const

Returns the `Gdk::EventSequence` that was last updated on gesture.

Returns
  The last updated sequence.

## ◆ get_point()

bool Gtk::Gesture::get_point | ( | Gdk::EventSequence * | sequence,
|  | double & | x,
|  | double & | y
| ) |  | const

If sequence is currently being interpreted by gesture, returns `true` and fills in x and y with the last coordinates stored for that event sequence.

The coordinates are always relative to the widget allocation.

Parameters

  sequence | A `Gdk::EventSequence`, or `nullptr` for pointer events.
  x | Return location for X axis of the sequence coordinates.
  y | Return location for Y axis of the sequence coordinates.

Returns
  `true` if sequence is currently interpreted.

## ◆ get_sequence_state()

EventSequenceState Gtk::Gesture::get_sequence_state | ( | Gdk::EventSequence * | sequence | ) | const

Returns the sequence state, as seen by gesture.

Parameters

  sequence | A `Gdk::EventSequence`.

Returns
  The sequence state in gesture.

## ◆ get_sequences()

std::vector< const Gdk::EventSequence * > Gtk::Gesture::get_sequences | ( |  | ) | const

Returns the list of Gdk::EventSequences currently being interpreted.

Since gtkmm 3.14:

Returns
  A std::vector of Gdk::EventSequence pointers. The Gdk::EventSequences are owned by GTK+ and must not be freed or modified.

## ◆ get_type()

static GType Gtk::Gesture::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkGesture * Gtk::Gesture::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkGesture * Gtk::Gesture::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkGesture * Gtk::Gesture::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ group()

void Gtk::Gesture::group | ( | const Glib::RefPtr< Gesture > & | group_gesture | ) |

Adds gesture to the same group than group_gesture.

Gestures are by default isolated in their own groups.

Both gestures must have been added to the same widget before they can be grouped.

When gestures are grouped, the state of `Gdk::EventSequences` is kept in sync for all of those, so calling set_sequence_state(), on one will transfer the same value to the others.

Groups also perform an "implicit grabbing" of sequences, if a `Gdk::EventSequence` state is set to Gtk::EventSequenceState::CLAIMED on one group, every other gesture group attached to the same `Gtk::Widget` will switch the state for that sequence to Gtk::EventSequenceState::DENIED.

Parameters

  group_gesture | `Gtk::Gesture` to group gesture with.

## ◆ handles_sequence()

bool Gtk::Gesture::handles_sequence | ( | Gdk::EventSequence * | sequence | ) | const

Returns `true` if gesture is currently handling events corresponding to sequence.

Parameters

  sequence | A `Gdk::EventSequence`.

Returns
  `true` if gesture is handling sequence, `false` otherwise.

## ◆ is_active()

bool Gtk::Gesture::is_active | ( |  | ) | const

Returns `true` if the gesture is currently active.

A gesture is active while there are touch sequences interacting with it.

Returns
  `true` if gesture is active.

## ◆ is_grouped_with()

bool Gtk::Gesture::is_grouped_with | ( | const Glib::RefPtr< Gesture > & | other | ) | const

Returns `true` if both gestures pertain to the same group.

Parameters

  other | Another `Gtk::Gesture`.

Returns
  Whether the gestures are grouped.

## ◆ is_recognized()

bool Gtk::Gesture::is_recognized | ( |  | ) | const

Returns `true` if the gesture is currently recognized.

A gesture is recognized if there are as many interacting touch sequences as required by gesture.

Returns
  `true` if gesture is recognized.

## ◆ operator=()

Gesture & Gtk::Gesture::operator= | ( | Gesture && | src | ) |
| noexcept

## ◆ property_n_points()

Glib::PropertyProxy_ReadOnly< unsigned int > Gtk::Gesture::property_n_points | ( |  | ) | const

The number of touch points that trigger recognition on this gesture.

Default value: 1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_sequence_state()

bool Gtk::Gesture::set_sequence_state | ( | Gdk::EventSequence * | sequence,
|  | EventSequenceState | state
| ) |  |

Sets the state of sequence in gesture.

Sequences start in state Gtk::EventSequenceState::NONE, and whenever they change state, they can never go back to that state. Likewise, sequences in state Gtk::EventSequenceState::DENIED cannot turn back to a not denied state. With these rules, the lifetime of an event sequence is constrained to the next four:

- None
- None → Denied
- None → Claimed
- None → Claimed → Denied

Note
  Due to event handling ordering, it may be unsafe to set the state on another gesture within a signal_begin() signal handler, as the callback might be executed before the other gesture knows about the sequence. A safe way to perform this could be:

[C example ellipted]

If both gestures are in the same group, just set the state on the gesture emitting the event, the sequence will be already be initialized to the group's global state when the second gesture processes the event.

Parameters

  sequence | A `Gdk::EventSequence`.
  state | The sequence state.

Returns
  `true` if sequence is handled by gesture, and the state is changed successfully.

## ◆ set_state()

bool Gtk::Gesture::set_state | ( | EventSequenceState | state | ) |

Sets the state of all sequences that gesture is currently interacting with.

See set_sequence_state() for more details on sequence states.

Parameters

  state | The sequence state.

Returns
  `true` if the state of at least one sequence was changed successfully.

## ◆ signal_begin()

Glib::SignalProxy< void(Gdk::EventSequence *)> Gtk::Gesture::signal_begin | ( |  | ) |

Slot Prototype:
  `void on_my_begin(Gdk::EventSequence* sequence)`

Flags: Run Last

Emitted when the gesture is recognized.

This means the number of touch sequences matches property_n_points().

Note
  These conditions may also happen when an extra touch (eg. a third touch on a 2-touches gesture) is lifted, in that situation sequence won't pertain to the current set of active touches, so don't rely on this being true.

Parameters

  sequence | The `Gdk::EventSequence` that made the gesture to be recognized.

## ◆ signal_cancel()

Glib::SignalProxy< void(Gdk::EventSequence *)> Gtk::Gesture::signal_cancel | ( |  | ) |

Slot Prototype:
  `void on_my_cancel(Gdk::EventSequence* sequence)`

Flags: Run Last

Emitted whenever a sequence is cancelled.

This usually happens on active touches when Gtk::EventController::reset() is called on gesture (manually, due to grabs...), or the individual sequence was claimed by parent widgets' controllers (see Gtk::Gesture::set_sequence_state()).

gesture must forget everything about sequence as in response to this signal.

Parameters

  sequence | The `Gdk::EventSequence` that was cancelled.

## ◆ signal_end()

Glib::SignalProxy< void(Gdk::EventSequence *)> Gtk::Gesture::signal_end | ( |  | ) |

Slot Prototype:
  `void on_my_end(Gdk::EventSequence* sequence)`

Flags: Run Last

Emitted when gesture either stopped recognizing the event sequences as something to be handled, or the number of touch sequences became higher or lower than property_n_points().

Note
  sequence might not pertain to the group of sequences that were previously triggering recognition on gesture (ie. a just pressed touch sequence that exceeds property_n_points()). This situation may be detected by checking through Gtk::Gesture::handles_sequence().

Parameters

  sequence | The `Gdk::EventSequence` that made gesture recognition to finish.

## ◆ signal_sequence_state_changed()

Glib::SignalProxy< void(Gdk::EventSequence *, EventSequenceState)> Gtk::Gesture::signal_sequence_state_changed | ( |  | ) |

Slot Prototype:
  `void on_my_sequence_state_changed(Gdk::EventSequence* sequence, EventSequenceState state)`

Flags: Run Last

Emitted whenever a sequence state changes.

See Gtk::Gesture::set_sequence_state() to know more about the expectable sequence lifetimes.

Parameters

  sequence | The `Gdk::EventSequence` that was cancelled.
  state | The new sequence state.

## ◆ signal_update()

Glib::SignalProxy< void(Gdk::EventSequence *)> Gtk::Gesture::signal_update | ( |  | ) |

Slot Prototype:
  `void on_my_update(Gdk::EventSequence* sequence)`

Flags: Run Last

Emitted whenever an event is handled while the gesture is recognized.

sequence is guaranteed to pertain to the set of active touches.

Parameters

  sequence | The `Gdk::EventSequence` that was updated.

## ◆ ungroup()

void Gtk::Gesture::ungroup | ( |  | ) |

Separates gesture into an isolated group.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::Gesture > wrap | ( | GtkGesture * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.